#!/bin/ksh
# Script de soumission Loadleveler, job Gaussian 98
# CRIHAN v 2.00
#
# Nom du job
# @ job_name = g98
#
# Nom du fichier de sortie standard
# @ output = $(job_name).o$(jobid)
#
# Nom du fichier d'erreur  standard
# @ error  = $(job_name).e$(jobid)
#
# Type du job
# @ cri_job_type = gaussian
#
# Nombre de processus Gaussian
# @ cri_total_tasks = 4
#
# temps de resitution (heures[:minutes[:secondes]])
# @ wall_clock_limit = 1:00:00
#
# Memoire maximale par processus (mb, gb, mw, gw, ..)
# @ data_limit  = 256mb
#
# Repertoire initial a envoyer
# @ cri_initialdir = /work/projet/login/IN_G98
#
# Repertoire final pour les resultats
# @ cri_finaldir = /work/projet/login/OUT_G98
#
# Politique d'envoi des e-mails
# @ notification = complete
#
# Adresse   d'envoi des e-mails
# @ notify_user = login@crihan.fr
#
# Obligatoire
# @ queue

###
### Commandes utilisateur
###

# On se positionne dans le repertoire de calcul
cd $LOCAL_WORK_DIR

#
# Variables d'environnements necessaires a Gaussian
#
set path=($path . /soft/g98)
export g98root=/soft
export GAUSS_SCRDIR=.
export GAUSS_EXEDIR=/soft/g98
export LD_LIBRARY64_PATH=/soft/g98

#
# Execution du job
#
g98 < molecule.com > molecule.log

#
# On deplace le fichier resultat dans le repertoire de SPOOL
#
gzip molecule.log molecule.chk

mv molecule.log.gz molecule.chk.gz $LOCAL_SPOOL_DIR

