#!/bin/csh
# Script de soumission Loadleveler, job Gamess
# CRIHAN v 2.00
#
# Nom du job
# @ job_name = Gamess
#
# Nom du fichier de sortie standard
# @ output = $(job_name).o$(jobid)
#
# Nom du fichier d'erreur  standard
# @ error  = $(job_name).e$(jobid)
#
# Type du job
# @ cri_job_type = gamess
#
# IMPORTANT :
# Gamess lance 2 processus par processeur donc positionnez le nombre
# de processeurs  la moitie du nombre de processus ($(cri_total_tasks)/2)
# Ici 4 processus donc execution sur 2 processeurs
# @ cri_total_tasks = 2
#
# Temps de restitution max du job (heures[:minutes[:secondes]])
# @ wall_clock_limit =  1:00:00
#
# Memoire maximale par processus (mb, gb, mw, gw, ..)
# @ data_limit = 1gb
#
# Repertoire initial a envoyer
# @ cri_initialdir = /work/projet/login/IN_gamess
#
# Repertoire final pour les resultats
# @ cri_finaldir = /work/projet/login/OUT_gamess
#
# Politique d'envoi des mels
# @ notification = complete
#
# Adresse d'envoi des mels
# @ notify_user = login@crihan.fr
#
# Obligatoire
# @ queue

#
# On se place dans le repertoire de calcul
#
cd $LOCAL_WORK_DIR

#
# Variables d'environnements necessaires a Gamess
#
setenv NBPROC 2
setenv SCR $LOCAL_WORK_DIR/.gamess.scr

#
# Execution du job
#
# sur 2 processeurs (cf NBPROC) mais avec 4 processus (cf cri_total_tasks)
./gamess exam33 2 > Gamess.out

#
# On deplace le fichier resultat dans le repertoire de SPOOL
#
mv *dat *log *out $LOCAL_SPOOL_DIR

