#!/bin/ksh
# Script de soumission Loadleveler, job Jaguar 6.0
# CRIHAN v 2.00
#
# Nom du job
# @ job_name = jaguar
#
# Nom du fichier de sortie standard
# @ output = $(job_name).o$(jobid)
#
# Nom du fichier d'erreur standard
# @ error = $(job_name).e$(jobid)
#
# Type du job
# @ cri_job_type = jaguar
#
# Nombre de processus Jaguar
# @ cri_total_tasks = 8
#
# temps de restitution (heures[:minutes[:secondes]])
# @ wall_clock_limit =  1:00:00
#
# Memoire maximale par processus (mb, gb, mw, gw, ..)
# @ data_limit = 1000mb
#
# Repertoire de depart a envoyer
# @ cri_initialdir = /work/projet/login/IN_jaguar
#
# Repertoire d'arrivee pour les resultats
# @ cri_finaldir = /work/projet/login/OUT_jaguar
#
# Politique d'envoi des mels
# @ notification = complete
#
# Adresse d'envoi des mels
# @ notify_user = login@crihan.fr
#
# Obligatoire
# @ queue 
#
###
### Commandes utilisateur
###

#
# On se positionne dans le repertoire de calcul
#
cd $LOCAL_WORK_DIR

#
# Variables d'environnements necessaires a Jaguar
#
export JAGUAR_HOME=/soft/jaguar6.0
export SCHRODINGER=/soft/jaguar6.0
export PATH=/soft/jaguar6.0:$PATH

#
# Constitution du fichier jaguar.hosts
#
$JAGUAR_HOME/make.hosts

#
# Execution du job
#
jaguar run -w -p 8 data.in > jaguar.out

#
# On deplace le fichier resultat dans le repertoire de SPOOL
#
mv *out *log $LOCAL_SPOOL_DIR
