#!/bin/csh
# Script de soumission Loadleveler, job Gamess
# CRIHAN v 3.00 - janvier 2006
# crihan-sci@crihan.fr
#
# Nom du job
# @ job_name = test_gamess
#
# Nom du fichier de sortie standard
# @ output = $(job_name).o$(jobid)
#
# Nom du fichier d'erreur  standard
# @ error  = $(job_name).e$(jobid)
#
# Type du job
# @ cri_job_type = gamess
#
# IMPORTANT :
# Gamess lance 2 processus par processeur donc positionnez le nombre
# de processeurs  la moitie du nombre de processus ($(cri_total_tasks)/2)
# Ici 4 processus donc execution sur 2 processeurs
# @ cri_total_tasks = 2
#
# Temps de restitution max du job (heures[:minutes[:secondes]])
# @ wall_clock_limit =  1:00:00
#
# Memoire maximale par processus (mb, gb, mw, gw, ..)
# @ data_limit = 1gb
#
# Stack maximale par processus (mb)
# @ stack_limit = 500mb
#
# Repertoire initial a envoyer
# @ cri_initialdir = /work/mon_projet/mon_login/TEST_gamess_IN
#
# Repertoire final pour les resultats
# @ cri_finaldir = /work/mon_projet/mon_login/TEST_gamess_OUT
#
# Politique d'envoi des mels
# @ notification = complete
#
# Adresse d'envoi des mels
# @ notify_user = mon_login@crihan.fr
#
# Obligatoire
# @ queue

#
# On se place dans le repertoire temporaire de calcul : $LOCAL_WORK_DIR
#
cd $LOCAL_WORK_DIR

#
# Variables d'environnements necessaires a Gamess
#
setenv NBPROC 2
setenv SCR $LOCAL_SCRATCH_DIR/.gamess.scr

#
# Execution du job
#
# sur 2 processeurs (cf NBPROC) mais avec 4 processus (cf cri_total_tasks)
./gamess exam33 2 > $LOCAL_SPOOL_DIR/Gamess.out

#
# On deplace les fichiers resultats dans le repertoire temporaire de rapatriement des donnees : $LOCAL_SPOOL_DIR
#
mv *dat  $LOCAL_SPOOL_DIR

