#!/bin/csh
# Script de soumission Loadleveler, job Gaussian 03, version c02
# CRIHAN v 3.00 - janvier 2006
# crihan-sci@crihan.fr
#
# Nom du job
# @ job_name = test_g03
#
# Nom du fichier de sortie standard
# @ output = $(job_name).o$(jobid)
#
# Nom du fichier d'erreur  standard
# @ error  = $(job_name).e$(jobid)
#
# Type du job
# @ cri_job_type = gaussian
#
# Nombre de processus Gaussian
# @ cri_total_tasks = 4
#
# temps de restitution (heures[:minutes[:secondes]])
# @ wall_clock_limit = 1:00:00
#
# Memoire maximale POUR L'APPLICATION (mb, gb, mw, gw, ..)
# @ data_limit  = 1256mb
#
# Stack maximale POUR L'APPLICATION (mb)
# @ stack_limit = 500mb
#
# Repertoire initial a envoyer
# @ cri_initialdir = /work/mon_projet/mon_login/TEST_G03_IN
#
# Repertoire final pour les resultats
# @ cri_finaldir = /work/mon_projet/mon_login/TEST_G03_OUT
#
# Politique d'envoi des mels
# @ notification = complete
#
# Adresse d'envoi des mels
# @ notify_user = mon_login@crihan.fr
#
# Obligatoire
# @ queue

###
### Commandes utilisateur
###

# On se positionne dans le repertoire temporaire de calcul : $LOCAL_WORK_DIR
cd $LOCAL_WORK_DIR

#
# Variables d'environnements necessaires a Gaussian
# $LOCAL_WORK_DIR    est un repertoire temporaire dans /dlocal (systeme de fichiers distant, partage)
# $LOCAL_SCRATCH_DIR est un repertoire temporaire dans /local  (systeme de fichiers propre au noeud, rapide)
#
setenv PATH "${PATH}:.:/soft/g03c02/g03"
setenv g03root /soft/g03c02
setenv GAUSS_SCRDIR $LOCAL_SCRATCH_DIR
setenv GAUSS_EXEDIR /soft/g03c02/g03
setenv LD_LIBRARY64_PATH /soft/g03c02/g03

#
# Execution du job
#
g03 < molecule.com > $LOCAL_SPOOL_DIR/molecule.log

#
# On deplace les fichiers resultats dans le repertoire temporaire de rapatriement des donnees : $LOCAL_SPOOL_DIR
#
mv molecule.chk $LOCAL_SPOOL_DIR
cd $LOCAL_SPOOL_DIR
gzip molecule.log molecule.chk
