#!/bin/csh
# Script de soumission Loadleveler, job Jaguar 4.1
# CRIHAN v 3.00 - janvier 2006
# crihan-sci@crihan.fr
#
# Nom du job
# @ job_name = test_jaguar
#
# Nom du fichier de sortie standard
# @ output = $(job_name).o$(jobid)
#
# Nom du fichier d'erreur standard
# @ error = $(job_name).e$(jobid)
#
# Type du job
# @ cri_job_type = jaguar
#
# Nombre de processus Jaguar
# @ cri_total_tasks = 4
#
# temps de restitution (heures[:minutes[:secondes]])
# @ wall_clock_limit =  8:00:00
#
# Memoire maximale par processus (mb, gb, mw, gw, ..)
# @ data_limit = 400mb
#
# Stack maximale par processus (mb)
# @ stack_limit = 100mb
#
# Repertoire de depart a envoyer
# @ cri_initialdir = /home/crihan/gm/Loadleveler/Scripts/jaguar
#
# Repertoire d'arrivee pour les resultats
# @ cri_finaldir = /home/crihan/gm/Loadleveler/Scripts/jaguar
#
# Politique d'envoi des mels
# @ notification = complete
#
# Adresse d'envoi des mels
# @ notify_user = gm@crihan.fr
#
# Obligatoire
# @ queue 
#
###
### Commandes utilisateur
###

#
# On se positionne dans le repertoire temporaire de calcul : $LOCAL_WORK_DIR
#
cd $LOCAL_WORK_DIR

#
# Variables d'environnements necessaires a Jaguar
#
setenv JAGUAR_HOME /soft/jaguar4.1
setenv SCHRODINGER /soft/jaguar4.1
setenv PATH "${PATH}:.:/soft/jaguar4.1"

#
# Constitution du fichier jaguar.hosts
#
$JAGUAR_HOME/make.hosts

#
# Execution du job
#
jaguar run -w -p 4 data.in > $LOCAL_SPOOL_DIR/jaguar.out

#
# On deplace les fichiers resultats dans le repertoire temporaire de rapatriement des donnees : $LOCAL_SPOOL_DIR
#
mv *log $LOCAL_SPOOL_DIR
